#!/usr/bin/python
#-*- coding: ISO-8859-1 -*- 

#***************************************************************************
#*   Copyright (C) 2008 by Victor J. Chamorro                              *
#*   ministropepon@esdebian.org                                            *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation, version 2 of the License         *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

from frmconfinicial import *
import os

class frmConfInicial(frmconfinicial):
	frmParent = ''
	
	def __tr(self,s,c = None):
		return qApp.translate("frmconfinicial",s,c)
	
	def next(self):
		
		print self.currentPage().name()
		
		if self.currentPage().name() == "WizardPage":
			
			# Del 1 al 2
			
			if self.chkLicencia.isOn():
				self.CargaIdiomas()
				self.showPage(self.WizardPage_2)
			return
		if self.currentPage().name() == "WizardPage_2":
			
			# Del 2 al 3
			# Actualizamos el idioma
			
			self.AplicaIdioma()
			
			self.showPage(self.WizardPage_3)
			print self.frmParent.conf.LeeConfiguracion('dbtype')
			if (self.frmParent.conf.LeeConfiguracion('dbtype') == 'mysql'):
				self.radSQLite.setOn(0)
				self.radMySQL.setOn(1)
			
			
			
			return
		if self.currentPage().name() == "WizardPage_3":
			
			# Del 3 al 4  5
			
			if self.radSQLite.isOn():
				if self.CompruebaSQLite():
					#Mostramos el ltimo
					
					self.loadFinishEvent()
					self.showPage(self.WizardPage_5)
					self.setFinishEnabled(self.WizardPage_5,1)
			else:
				if self.CompruebaMySQLdb():
					#Mostramos la configuracin de MySQL
					self.showPage(self.WizardPage_4)
					
					self.txtHost.setText(self.frmParent.conf.LeeConfiguracion('host'))
					self.txtUser.setText(self.frmParent.conf.LeeConfiguracion('user'))
					self.txtPassword.setText(self.frmParent.conf.LeeConfiguracion('pass'))
					self.txtDbname.setText(self.frmParent.conf.LeeConfiguracion('dbname'))
					
			return
		if self.currentPage().name() == "WizardPage_4":
			
			# Del 4 al 5
			
			if self.CompruebaConexionMySQL():
				self.loadFinishEvent()
				self.showPage(self.WizardPage_5)
				self.setFinishEnabled(self.WizardPage_5,1)
			return
		
	
	def back(self):
		
		print self.currentPage().name()
		
		if self.currentPage().name() == "WizardPage_5":
			if self.radSQLite.isOn():
				self.showPage(self.WizardPage_3)
			else:
				self.showPage(self.WizardPage_4)
			return
		if self.currentPage().name() == "WizardPage_4":
			self.showPage(self.WizardPage_3)
			return
		if self.currentPage().name() == "WizardPage_3":
			self.showPage(self.WizardPage_2)
			return
		if self.currentPage().name() == "WizardPage_2":
			self.showPage(self.WizardPage)
			return
		
	def chkLicenciaChange(self):
		#Si no ha checkeado, no le dejamos seguir
		if self.chkLicencia.isOn():
			self.setNextEnabled(self.WizardPage,1)
		else:
			self.setNextEnabled(self.WizardPage,0)
		
	def CompruebaMySQLdb(self):
		
		try:
			import MySQLdb
			print "MySQLdb cargada correctamente."
			return 1
		except ImportError:
			QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo cargar la extensin MySQL. Compruebe que esta instalado el paquete python-mysqldb"))
			return 0
		
	def CompruebaSQLite(self):
		
		try:
				
			try: 
				import sqlite3 as dbapi
			except ImportError:
				from pysqlite2 import dbapi2 as dbapi
			
			print "SQLite cargado"
			return 1
		except:
			QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo cargar la extensin SQLlite."))
			return 0
		
	def btnProbarClick(self):
		if (self.CompruebaConexionMySQL() and self.correctdbname):
			QMessageBox.information(self,"sMovieDB - Informacin",self.__tr("Conexin establecida correctamente."))
		
	def CompruebaConexionMySQL(self):
		
		try:
			import MySQLdb
			self.db = MySQLdb.connect(host=str(self.txtHost.text()),user=str(self.txtUser.text()),passwd=str(self.txtPassword.text()),db='')
			self.dbconn = self.db.cursor()
			try:
				self.dbconn.execute("USE "+str(self.txtDbname.text()))
				self.correctdbname = 1
			except:
				QMessageBox.information(self,"sMovieDB - Informacin",self.__tr("La conexin se ha establecido correctamente pero\nla base de datos <<"+str(self.txtDbname.text())+">> parece no existir. Se intentar crear con una estructura inicial."))
				self.correctdbname = 0
			#self.db.close()
			return 1
		except:
			QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo conectar con el servidor MySQL con los datos facilitados.\nCompruebe que todos los datos son correctos"))
		return 0
	
	def CargaIdiomas(self):
		
		print "Detectando idiomas..."
		self.dirname = "./langs"
		
		#self.ddlIdioma.insertItem("")
		for f in os.listdir(self.dirname):
			fichero = os.path.join(self.dirname, f)
			if (os.path.isfile(fichero) and f[-2:]=="qm"):
				self.ddlIdioma.insertItem(f[:-3])
		return
	
	def AplicaIdioma(self):
		translator = QTranslator(qApp)
		a=translator.load(self.dirname+"/"+str(self.ddlIdioma.currentText())+".qm")
		
		if a==0:
			QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al cargar el idioma'))
			print "No translation for "+self.ddlIdioma.currentText()+"\nNo se encuentra el idioma "+self.ddlIdioma.currentText()
		else:
			qApp.installTranslator(translator)
			self.nextButton().setText(self.__tr("Siguiente >"))
			self.backButton().setText(self.__tr("< Atrs"))
			self.cancelButton().setText(self.__tr("Cancelar"))
			self.finishButton().setText(self.__tr("Finalizar"))
			self.languageChange()
			
			#self.frmParent.languageChange()
			
	def loadFinishEvent(self):
		#Asociamos el evento clicked del botn finalizar a la funcin self.Finalizar
		self.connect(self.finishButton(),SIGNAL("clicked()"),self.Finalizar)
		return
	
	def Finalizar(self):
		print "Aplicamos todas las configuraciones"
		
		#Aplicamos el idioma
		self.frmParent.languageChange()
		idioma = self.ddlIdioma.currentText()
		
		
		#Datos de BD
		tipobd=''
		dbname=''
		if self.radSQLite.isOn():
			tipobd = 'sqlite'
			host = ''
			user = ''
			passw = ''
			dbname = ''
			self.correctdbname = 0
		else:
			tipobd = 'mysql'
			host = self.txtHost.text()
			user = self.txtUser.text()
			passw = self.txtPassword.text()
			dbname = self.txtDbname.text()
		
		data = ''
		data = data + host + "\n"
		data = data + user + "\n"
		data = data + passw + "\n"
		data = data + dbname + "\n"
		data = data + tipobd + "\n"
		data = data + idioma + "\n"
		
		self.frmParent.conf.GuardaConfiguracion('host', host)
		self.frmParent.conf.GuardaConfiguracion('user', user)
		self.frmParent.conf.GuardaConfiguracion('pass', passw)
		self.frmParent.conf.GuardaConfiguracion('dbname', dbname)
		self.frmParent.conf.GuardaConfiguracion('dbtype', tipobd)
		self.frmParent.conf.GuardaConfiguracion('idioma', idioma)
		
		#print data
		#print tipobd+'-'+str(self.correctdbname)
		# Si la base de datos (mysql) no existe la creamos con la estructura inicial
		
		if (tipobd == 'mysql' and self.chkSobreescribirDB.isOn()):
			try:
				self.dbconn.execute(str("DROP DATABASE `"+dbname+"`"))
			except:
				print "No se ha podido eliminar la base de datos "+dbname
				
			self.correctdbname = 0

		
		if (tipobd == 'mysql' and self.correctdbname == 0):
			
			try:
				sql = "CREATE DATABASE `"+dbname+"`"
				print "Intentamos crear la base de datos ("+sql+")..."
				self.dbconn.execute(str(sql))
				self.dbconn.execute(str("USE `"+dbname+"`"))
				#Abrimos el fichero sql.sql que tiene la estructura inicial de la BD
				print "Intentamos cargar la estructura desde el fichero sql.sql..."
				fsql = open('./sql.sql','r')
				buffer = fsql.read()
				fsql.close()
				sql = buffer.split(';')
				
				for sentencia in sql:
					if len(sentencia)>0:
						print "Ejecutando "+sentencia+"..."
						self.dbconn.execute(str(sentencia))

			except:
				QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al crear la base de datos'))
			
			
		# Ahora guardamos los datos en el fichero de configuracin
		
		#fconfig = self.frmParent.AbreFileConfig('w')
		#fconfig.write(data)
		#fconfig.close()
		self.frmParent.conf.GuardarFichero()
		
		self.frmParent.conectar()
		self.frmParent.preferencias()
		return