#!/usr/bin/python
#-*- coding: ISO-8859-1 -*- 

#***************************************************************************
#*   Copyright (C) 2008 by Victor J. Chamorro                              *
#*   ministropepon@esdebian.org                                            *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation, version 2 of the License         *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************
 
from frmidiomas import *
import os

class frmIdioma(frmidioma):
	
	def __tr(self,s,c = None):
		return qApp.translate("frmsmoviedb",s,c)
	
	def cargar(self, frm):
		
		self.dirname = "./langs"
		self.frmParent = frm
		self.ddlIdioma.insertItem("")
		for f in os.listdir(self.dirname):
			fichero = os.path.join(self.dirname, f)
			if (os.path.isfile(fichero) and f[-2:]=="qm"):
				self.ddlIdioma.insertItem(f[:-3])

	
	def aceptar(self):
		
		#file = self.frmParent.AbreFileConfig()
		#buffer = file.read()
		#file.close()
		
		#config = buffer.split('\n')
		
		
		
		translator = QTranslator(qApp)
		a=translator.load(self.dirname+"/"+str(self.ddlIdioma.currentText())+".qm")
		
		if a==0:
			QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al cargar el idioma'))
			print "No translation for "+self.ddlIdioma.currentText()+"\nNo se encuentra el idioma "+self.ddlIdioma.currentText()
		else:
			qApp.installTranslator(translator)
			QMessageBox.information(self,self.__tr('sMovieDB - Invormacin'),self.__tr('El idioma ')+self.ddlIdioma.currentText()+self.__tr(' ser cargado completamente al reiniciar la aplicacin'))
			
			#fconfig = self.frmParent.AbreFileConfig('w')
			
			#if len(config)<5:
				#txtconfig = "\n\n\n\n\n"+self.ddlIdioma.currentText()+"\n"
			#else:
				#txtconfig = config[0]+"\n"+config[1]+"\n"+config[2]+"\n"+config[3]+"\n"+config[4]+"\n"+self.ddlIdioma.currentText()+"\n"
			
			#fconfig.write(txtconfig)
			#fconfig.close()
			
			self.frmParent.conf.GuardaConfiguracion('idioma', self.ddlIdioma.currentText())
			self.frmParent.conf.GuardarFichero()
			
			
			self.frmParent.languageChange()
			
			self.close()
			
		
	