#!/usr/bin/python
#-*- coding: ISO-8859-1 -*- 

#***************************************************************************
#*   Copyright (C) 2008 by Victor J. Chamorro                              *
#*   ministropepon@esdebian.org                                            *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation, version 2 of the License                *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

#Importamos el mdulo ConfigParser

import os
import ConfigParser
#para el copy
import shutil
from qt import *

class configuracion():
	
	def __tr(self,s,c = None):
		return qApp.translate("frmsmoviedb",s,c)
	
	def AbreFileConfig(self, modo='r'):
		self.conffile = os.environ["HOME"] + "/.smoviedb/smoviedbv2.conf"
		self.datfile = os.environ["HOME"] + "/.smoviedb/smoviedb.dat"
		self.confdir = os.environ["HOME"] + "/.smoviedb/"
		primeravez = 0
		
		buffer = ''
		touch = lambda file: open(self.conffile, "w").close() # Reemplazo para touch
		
		try:
        		fconfig = open(self.conffile,modo)
		except IOError:
			print "el fichero de configuracion no existe, intentando crearlo"
			try:
            			touch(self.conffile)
			except IOError:
				print "el directorio de configuracion no existe, intentando crearla"
				try:
					os.mkdir(self.confdir)
				except IOError:
					print "Error de E/S, permisos insuficientes"
					return 0
				else:
					touch(self.conffile)
                			fconfig = open(self.conffile,modo)
			else:
				fconfig = open(self.conffile,modo)
			primeravez = 1
		try:
			dat = open(self.datfile,"r")
		except IOError:
			print "el fichero dat de SQLite no existe, intentando crearlo"
			try:
				shutil.copy("data/smoviedb.dat", os.environ["HOME"] + "/.smoviedb/smoviedb.dat")
			except IOError:
				print "el directorio de configuracion no existe, intentando crearla"
				try:
					os.mkdir(self.confdir)
				except IOError:
					print "Error de E/S, permisos insuficientes"
					return 0
				else:
					shutil.copy("data/smoviedb.dat", os.environ["HOME"] + "/.smoviedb/smoviedb.dat")
			#primeravez = 1
		else:
			dat.close()
		
		#Si el fichero de configuracin o la carpeta no existe, arrancamos el asistente de configuracin:
		#if (primeravez == 1):
			#try: fconfig.close()
			#except: error = 1
			#self.asistenteConfInicial()
			#fconfig = open(self.conffile,modo)
			
		return fconfig
			
	def CargaConfiguracion(self):
		fconfig = self.AbreFileConfig()
		dic_configuracion = {}
		self.config = ConfigParser.ConfigParser()
		try:
			self.config.read(self.conffile)
		except:
			#QMessageBox.critical(self,self.__tr('sMovieDB - Informacin'),self.__tr('Fallo la lectura del archivo de configuracin.'))
			print "Fallo la lectura del archivo de configuracion"
		
		#print "secciones:"+self.config.items('general').len()
		if len(self.config.sections()) == 0:
			self.config.add_section('general')
			self.config.add_section('vista')
		
		#for opt,value in self.config.items('general'):
		#	print opt,value
		fconfig.close()
		
		return dic_configuracion
		
	def LeeConfiguracion(self,dato,seccion='general'):
		try:
			return self.config.get(seccion,dato)
		except:
			#print "Error al leer el parmetro de configuracin "+dato
			return ''
	
	def GuardaConfiguracion(self,dato,valor,seccion='general'):
		try:
			# Si la seccin a la que intentamos guardar no existe, la intentamos crear
			if (seccion in self.config.sections()) == 0:
				print "La seccion no exite en la configuracin, se intenta crear."
				self.config.add_section(seccion)
				
			self.config.set(seccion,dato, valor)
			return 1
		except:
			#print "Error al guardar el parmetro de configuracin "+dato
			return 0
	
	def GuardarFichero(self):
		fconfig = self.AbreFileConfig('w')
		self.config.write(fconfig)
		fconfig.close()
		self.CargaConfiguracion()
		

	def __init__(self):
		self.CargaConfiguracion()