#!/usr/bin/python
#-*- coding: ISO-8859-1 -*- 

#***************************************************************************
#*   Copyright (C) 2008 by Victor J. Chamorro                              *
#*   ministropepon@esdebian.org                                            *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation, version 2 of the License         *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

from frmpreferencias import *
from smoviedb import *
import os

class preferencias(frmPreferencias):
	
	def __tr(self,s,c = None):
		return qApp.translate("frmPreferencias",s,c)
	
	def onload(self,parent):
		
		self.frmParent = parent
		
		
		#file = self.frmParent.AbreFileConfig()
		#buffer = file.read()
		#file.close()
		
		# Bug critico 2468611, no permite guardar las preferencias si no se ha especificado un idioma 
		self.idioma = ""
		
		#Si el fichero de configuracin no tiene datos, no cargamos
		#config = buffer.split('\n')
		
		
		#if len(config) >= 5:
		
		self.txtHost.setText(self.frmParent.conf.LeeConfiguracion('host'))
		self.txtUser.setText(self.frmParent.conf.LeeConfiguracion('user'))
		self.txtPassword.setText(self.frmParent.conf.LeeConfiguracion('pass'))
		self.txtDbname.setText(self.frmParent.conf.LeeConfiguracion('dbname'))
		if self.frmParent.conf.LeeConfiguracion('autoconnect') == "1":
			self.chkAutoconectar.setDown(1)
			self.chkAutoconectar.setOn(1)
		else:
			self.chkAutoconectar.setDown(0)
			print self.frmParent.conf.LeeConfiguracion('autoconnect')
		
		
		if (self.frmParent.conf.LeeConfiguracion('dbtype') == 'mysql'):
			self.ddlTipoBaseDatos.setCurrentItem(1)
			self.ddlTipoBaseDatos_change(1)
		#if config[5] != "":
		#	self.idioma = config[5]
		self.idioma = self.frmParent.conf.LeeConfiguracion('idioma')
			# Bug critico 2468611, no permite guardar las preferencias si no se ha especificado un idioma 
			#else:
			#	self.idioma = ""
		
		
		# Si no esta conectado, no cargamos ms
		
		if self.frmParent.conectado == 0:
			self.tabWidget2.setTabEnabled(self.tab_2,0)
			self.tabWidget2.setTabEnabled(self.TabPage,0)
			self.tabWidget2.setTabEnabled(self.TabPage_2,0)
			self.tabWidget2.setTabEnabled(self.TabPage_3,0)
			return
		
		self.tabWidget2.setTabEnabled(self.tab_2,1)
		self.tabWidget2.setTabEnabled(self.TabPage,1)
		self.tabWidget2.setTabEnabled(self.TabPage_2,1)
		self.tabWidget2.setTabEnabled(self.TabPage_3,1)
		#self.btnAceptarGenero.setEnabled(1)
		#self.btnAceptarFormato.setEnabled(1)
		#self.btnAceptarTipo.setEnabled(1)
		#self.btnAceptarLocalizacion.setEnabled(1)
		
		#self.btnNuevoGenero.setEnabled(1)
		#self.btnNuevoFormato.setEnabled(1)
		#self.btnNuevoTipo.setEnabled(1)
		#self.btnNuevaLocalizacion.setEnabled(1)
		
		self.dbconn = self.frmParent.dbconn
		self.llenaGeneros()
		self.llenaFormatos()
		self.llenaddlTipos()
		self.llenaddlLocalizaciones()
		self.generos_eliminados=[]
		self.formatos_eliminados=[]
		self.localizaciones_eliminadas=[]
		self.tipos_eliminados=[]
		
	def ddlTipoBaseDatos_change(self, n):
		if (n==1):
			self.grpMysql.setEnabled(1)
		else:
			self.grpMysql.setEnabled(0)
	
	def llenaGeneros(self):
		sql = "SELECT id, nombre from generos where borrado = 0 order by nombre asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		self.lstGeneros.clear()
		self.generos = {}
		self.generos_pos = {}
		i=1
		for genero in rs:
			self.generos[genero[0]] = genero[1]
			self.generos_pos[i]=genero[0]
			self.lstGeneros.insertItem(genero[1])
			i=i+1
	
	def llenaFormatos(self):
		sql = "SELECT id, nombre from formatos where borrado = 0 order by nombre asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		self.lstFormatos.clear()
		self.formatos = {}
		self.formatos_pos = {}
		i=1
		for formato in rs:
			self.formatos[formato[0]] = formato[1]
			self.formatos_pos[i]=formato[0]
			self.lstFormatos.insertItem(formato[1])
			i=i+1
	
	def llenaddlTipos(self):
		sql = "SELECT id, nombre from tipos where borrado = 0 order by nombre asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		self.lstTipos.clear()
		self.tipos = {}
		self.tipos_pos = {}
		i=1
		for tipo in rs:
			self.tipos[tipo[0]]=tipo[1]
			self.tipos_pos[i] = tipo[0]
			self.lstTipos.insertItem(tipo[1],tipo[0])
			i=i+1
			
	def llenaddlLocalizaciones(self):
		sql = "SELECT * from localizaciones where borrado = 0 order by nombre asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		self.lstLocalizaciones.clear()
		self.localizaciones={}
		self.localizaciones_pos = {}
		i=1
		for localizacion in rs:
			self.localizaciones[localizacion[0]] = localizacion[1]
			self.localizaciones_pos[i] = localizacion[0]
			self.lstLocalizaciones.insertItem(localizacion[1])
			i=i+1
	
	#______________________________________________________________________________________________________
	#	Pestaa Generos
	
	def lstGeneros_click(self,item):
		try:
			self.txtEditarGenero.setText(item.text())
		except:
			return
		
	def aceptarGeneros(self):
		if self.txtEditarGenero.text().length()>0:
			self.lstGeneros.changeItem(self.txtEditarGenero.text(),self.lstGeneros.currentItem())
			self.generos[self.generos_pos[self.lstGeneros.currentItem()+1]] = self.frmParent.codifica(self.txtEditarGenero.text())
	
	def eliminarGeneros(self):
		self.generos_eliminados.append(self.generos_pos[self.lstGeneros.currentItem()+1])
		del self.generos[self.generos_pos[self.lstGeneros.currentItem()+1]]
		self.lstGeneros.removeItem(self.lstGeneros.currentItem())
		self.txtEditarGenero.setText("")
	
	def nuevoGenero(self):
		self.lstGeneros.insertItem(self.txtCrearGenero.text())
		self.generos['n'+self.frmParent.codifica(self.txtCrearGenero.text())] = self.frmParent.codifica(self.txtCrearGenero.text())
		self.generos_pos[self.lstGeneros.count()]='n'+self.frmParent.codifica(self.txtCrearGenero.text())
		self.txtCrearGenero.setText("")
		
	#______________________________________________________________________________________________________
	#	Pestaa Formatos
	
	def lstFormatos_click(self,item):
		try:
			self.txtEditarFormato.setText(item.text())
		except:
			return
		
	def aceptarFormatos(self):
		if self.txtEditarFormato.text().length()>0:
			self.lstFormatos.changeItem(self.txtEditarFormato.text(),self.lstFormatos.currentItem())
			self.formatos[self.formatos_pos[self.lstFormatos.currentItem()+1]] = self.frmParent.codifica(self.txtEditarFormato.text())
	
	def eliminarFormatos(self):
		self.formatos_eliminados.append(self.formatos_pos[self.lstFormatos.currentItem()+1])
		del self.formatos[self.formatos_pos[self.lstFormatos.currentItem()+1]]
		self.lstFormatos.removeItem(self.lstFormatos.currentItem())
		self.txtEditarFormato.setText("")
	
	def nuevoFormato(self):
		self.lstFormatos.insertItem(self.txtCrearFormato.text())
		self.formatos['n'+self.frmParent.codifica(self.txtCrearFormato.text())] = self.frmParent.codifica(self.txtCrearFormato.text())
		self.formatos_pos[self.lstFormatos.count()]='n'+self.frmParent.codifica(self.txtCrearFormato.text())
		self.txtCrearFormato.setText("")
		
	#______________________________________________________________________________________________________
	#	Pestaa Tipos
	
	def lstTipos_click(self,item):
		try:
			self.txtEditarTipo.setText(item.text())
		except:
			return
		
	def aceptarTipos(self):
		if self.txtEditarTipo.text().length()>0:
			self.lstTipos.changeItem(self.txtEditarTipo.text(),self.lstTipos.currentItem())
			self.tipos[self.tipos_pos[self.lstTipos.currentItem()+1]] = self.frmParent.codifica(self.txtEditarTipo.text())
	
	def eliminarTipos(self):
		self.tipos_eliminados.append(self.tipos_pos[self.lstTipos.currentItem()+1])
		del self.tipos[self.tipos_pos[self.lstTipos.currentItem()+1]]
		self.lstTipos.removeItem(self.lstTipos.currentItem())
		self.txtEditarTipo.setText("")
	
	def nuevoTipo(self):
		self.lstTipos.insertItem(self.txtCrearTipo.text())
		self.tipos['n'+self.frmParent.codifica(self.txtCrearTipo.text())] = self.frmParent.codifica(self.txtCrearTipo.text())
		self.tipos_pos[self.lstTipos.count()]='n'+self.frmParent.codifica(self.txtCrearTipo.text())
		self.txtCrearTipo.setText("")	
	
	#______________________________________________________________________________________________________
	#	Pestaa Localizaciones
	
	def lstLocalizaciones_click(self,item):
		try:
			self.txtEditarLocalizacion.setText(item.text())
		except:
			return
		
	def aceptarLocalizaciones(self):
		if self.txtEditarLocalizacion.text().length()>0:
			self.lstLocalizaciones.changeItem(self.txtEditarLocalizacion.text(),self.lstLocalizaciones.currentItem())
			self.localizaciones[self.localizaciones_pos[self.lstLocalizaciones.currentItem()+1]] = self.frmParent.codifica(self.txtEditarLocalizacion.text())
	
	def eliminarLocalizacion(self):
		self.localizaciones_eliminadas.append(self.localizaciones_pos[self.lstLocalizaciones.currentItem()+1])
		del self.localizaciones[self.localizaciones_pos[self.lstLocalizaciones.currentItem()+1]]
		self.lstLocalizaciones.removeItem(self.lstLocalizaciones.currentItem())
		self.txtEditarLocalizacion.setText("")
	
	def nuevaLocalizacion(self):
		self.lstLocalizaciones.insertItem(self.txtCrearLocalizacion.text())
		self.localizaciones['n'+self.frmParent.codifica(self.txtCrearLocalizacion.text())] = self.frmParent.codifica(self.txtCrearLocalizacion.text())
		self.localizaciones_pos[self.lstLocalizaciones.count()]='n'+self.frmParent.codifica(self.txtCrearLocalizacion.text())
		self.txtCrearLocalizacion.setText("")	
	
	#______________________________________________________________________________________________________
	#	Guardar los cambios
	
	def aceptar(self):
		
		#config = self.txtHost.text()+"\n"+self.txtUser.text()+"\n"+self.txtPassword.text()+"\n"+self.txtDbname.text()+"\n"
		#if (self.ddlTipoBaseDatos.currentItem() == 0):
			#config = config + 'sqlite\n'
		#else:
			#config = config + 'mysql\n'
			
		#config = config + self.idioma + '\n'
		
		#fconfig = self.frmParent.AbreFileConfig('w')
		
		#fconfig.write(config)
		#fconfig.close()
		#print "guardado datos de conexion"
		
		
		self.frmParent.conf.GuardaConfiguracion('host', self.txtHost.text())
		self.frmParent.conf.GuardaConfiguracion('user', self.txtUser.text())
		self.frmParent.conf.GuardaConfiguracion('pass', self.txtPassword.text())
		self.frmParent.conf.GuardaConfiguracion('dbname', self.txtDbname.text())
		#self.frmParent.conf.GuardaConfiguracion('autoconnect', int(not self.chkAutoconectar.isDown()))
		self.frmParent.conf.GuardaConfiguracion('autoconnect', int( self.chkAutoconectar.isOn()))
		if (self.ddlTipoBaseDatos.currentItem() == 0):
			self.frmParent.conf.GuardaConfiguracion('dbtype', 'sqlite')
		else:
			self.frmParent.conf.GuardaConfiguracion('dbtype', 'mysql')
		self.frmParent.conf.GuardarFichero()
		
		if self.frmParent.conectado == 0:
			self.close()
			return
		
		#__Guardar datos de gneros
		
		for genero in self.generos:
			
			if str(genero)[0] == "n":
				#Esto es un elemento nuevo,insertamos
				sql = "INSERT INTO generos (id,nombre,borrado) VALUES (NULL,'"+self.generos[genero]+"',0)"
			else:
				#Esto es un elemento existente,actualizamos
				sql = "UPDATE generos SET nombre = '"+self.generos[genero]+"' WHERE id="+str(genero)
			try:
				self.dbconn.execute(str(sql))
			except:
				print "Error al guardar los generos: "+sql
				QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
		
		for genero_eliminado in self.generos_eliminados:
			if str(genero_eliminado)[0] != "n":
				sql = "UPDATE generos SET borrado = 1 WHERE id="+str(genero_eliminado)
				try:
					self.dbconn.execute(sql)
				except:
					print "Error al guardar los generos: "+sql
					QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
		
		#__Guardar datos de formatos
		
		for formato in self.formatos:
			
			if str(formato)[0] == "n":
				#Esto es un elemento nuevo,insertamos
				sql = "INSERT INTO formatos (id,nombre,borrado) VALUES (NULL,'"+self.formatos[formato]+"',0)"
			else:
				#Esto es un elemento existente,actualizamos
				sql = "UPDATE formatos SET nombre = '"+self.formatos[formato]+"' WHERE id="+str(formato)
			try:
				self.dbconn.execute(sql)
			except:
				print "Error al guardar los generos: "+sql
				QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
		
		for formato_eliminado in self.formatos_eliminados:
			if str(formato_eliminado)[0] != "n":
				sql = "UPDATE formatos SET borrado = 1 WHERE id="+str(formato_eliminado)
				try:
					self.dbconn.execute(sql)
				except:
					print "Error al guardar los formatos: "+sql
					QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
		
		#__Guardar datos de Tipos
		
		for tipo in self.tipos:
			
			if str(tipo)[0] == "n":
				#Esto es un elemento nuevo,insertamos
				sql = "INSERT INTO tipos (id,nombre,borrado) VALUES (NULL,'"+self.tipos[tipo]+"',0)"
			else:
				#Esto es un elemento existente,actualizamos
				sql = "UPDATE tipos SET nombre = '"+self.tipos[tipo]+"' WHERE id="+str(tipo)
			try:
				self.dbconn.execute(sql)
			except:
				print "Error al guardar los Tipos: "+sql
				QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
		
		for tipo_eliminado in self.tipos_eliminados:
			if str(tipo_eliminado)[0] != "n":
				sql = "UPDATE tipos SET borrado = 1 WHERE id="+str(tipo_eliminado)
				try:
					self.dbconn.execute(sql)
				except:
					print "Error al guardar los tipos: "+sql
					QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
		
		
		#__Guardar datos de Localizaciones
		
		for localizacion in self.localizaciones:
			
			if str(localizacion)[0] == "n":
				#Esto es un elemento nuevo,insertamos
				sql = "INSERT INTO localizaciones (id,nombre,borrado) VALUES (NULL,'"+self.localizaciones[localizacion]+"',0)"
			else:
				#Esto es un elemento existente,actualizamos
				sql = "UPDATE localizaciones SET nombre = '"+self.localizaciones[localizacion]+"' WHERE id="+str(localizacion)
			try:
				self.dbconn.execute(sql)
			except:
				print "Error al guardar las Localizaciones: "+sql
				QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
		
		for localizacion_eliminada in self.localizaciones_eliminadas:
			
			if str(localizacion_eliminada)[0] != "n":
				sql = "UPDATE localizaciones SET borrado = 1 WHERE id='"+str(localizacion_eliminada)+"'"
				try:
					self.dbconn.execute(sql)
				except:
					print "Error al guardar los tipos: "+sql
					QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardas las preferencias'))
					
		
		self.frmParent.db.commit()
		self.frmParent.conectar()
		self.close()
		