#!/usr/bin/python
#-*- coding: ISO-8859-1 -*- 

#***************************************************************************
#*   Copyright (C) 2008 by Victor J. Chamorro                              *
#*   ministropepon@esdebian.org                                            *
#*                                                                         *
#*   This program is free software; you can redistribute it and/or modify  *
#*   it under the terms of the GNU General Public License as published by  *
#*   the Free Software Foundation, version 2 of the License                *
#*                                                                         *
#*   This program is distributed in the hope that it will be useful,       *
#*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
#*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
#*   GNU General Public License for more details.                          *
#*                                                                         *
#*   You should have received a copy of the GNU General Public License     *
#*   along with this program; if not, write to the                         *
#*   Free Software Foundation, Inc.,                                       *
#*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#***************************************************************************

#Importamos las librerias de QT como modulo de Python

import sys
import base64

from qt import *
from qttable import *

#para el copy
import shutil



app = ""
#Intentamos importar las librerias de KDE para integracin total con KDE
#try:
	#from kdeui import *
	#from kdecore import *
	#from kfile import *
	#kde = 1
#except:
	#kde = 0
	#print "No KDE librarys"



# Importamos el formulario
from frmsmoviedb import * 
from frminsertar import *
from preferencias import *
from frmabout import *
from idioma import *
from confinicial import *
from configuracion import *

version = "0.80 Beta"


class frmMovie(frmsmoviedb):
	
	#def __init__(self):
		#self.conf = configuracion()
		
	
	def __tr(self,s,c = None):
		return qApp.translate("frmsmoviedb",s,c)

	def buscar(self):
		if self.conectado!=0:
			self.setCursor(QCursor(3))
			self.llenaTabla()
			self.setCursor(QCursor(0))
		else:
			QMessageBox.information(self,self.__tr('sMovieDB - Informacin'), self.__tr('Debe estar conectado para poder buscar'))
			
	def ayudabasedatos(self):
		QMessageBox.information(self,self.__tr('sMovieDB - Informacin'),self.__tr('Para crear la estructura inicial de base de datos debe importar el fichero sql.sql en MySQL\n(/usr/share/smoviedb/sql.sql)'))
		
	def conectar(self):
		
		
		self.setCursor(QCursor(3))
		
		self.dbtype='sqlite'	# por defecto usamos SQLite
			
		if (self.conf.LeeConfiguracion('dbtype') == 'mysql'):
			
			# MySQL
			
			try:
				import MySQLdb
			except:
				QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo cargar la extensin MySQL. Compruebe que esta instalado el paquete python-mysqldb"))
				self.setCursor(QCursor(0))
				return
			
			try:				
				self.db = MySQLdb.connect(host=self.conf.LeeConfiguracion('host'),user=self.conf.LeeConfiguracion('user'),passwd=self.conf.LeeConfiguracion('pass'),db=self.conf.LeeConfiguracion('dbname'))
			except:
				print "error al conectar"
				QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo conectar con la base de datos,\nrevise las preferencias"))
				self.setCursor(QCursor(0))
				return
			
			self.dbtype='mysql'
		
			
		if (self.dbtype=='sqlite'):
			
			# Sqlite
			try:
				
				try: import sqlite3 as dbapi
				except ImportError: from pysqlite2 import dbapi2 as dbapi


			except:
				QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo cargar la extensin SQLlite."))
				self.setCursor(QCursor(0))
				return
			
			try:				
				self.db = dbapi.connect(os.environ["HOME"] + "/.smoviedb/smoviedb.dat")
			except:
				print "error al conectar"
				QMessageBox.critical(self,"sMovieDB - Error",self.__tr("No se pudo conectar con la base de datos"))
				self.setCursor(QCursor(0))
				return
			
			self.dbtype='sqlite'
		
		#try:
		self.conectado = 1
		self.dbconn = self.db.cursor()
		self.llenaddlGenero()
		self.llenaddlTipo()
		self.llenaddlFormato()
		self.llenaddlAnio()
		self.llenaddlLocalizacion()
		self.llenaTabla(0)
		self.llenalstCatalogo()
		self.btnInsertar.setEnabled(1)
		self.accionInsertar.setEnabled(1)
		self.tbResultados.setEnabled(1)
		self.lstCatalogo.setEnabled(1)
		self.btnConectar.setText(self.__tr('Re-&conectar'))
		self.setCursor(QCursor(0))
		#except:
			#QMessageBox.critical(self,"sMovieDB - Error",self.__tr("Error desconocido al intentar completar los datos"))
			#self.setCursor(QCursor(0))
			#return
		
	def llenaddlGenero(self):
		sql = "SELECT id, nombre from generos where borrado = 0 order by nombre asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		self.ddlGenero.clear()
		self.ddlGenero.insertItem("",0)
		self.generos = {}
		self.generos_pos = {}
		self.generos_count = {}
		self.generos_id = {}
		i=1
		for genero in rs:
			self.generos[genero[0]] = genero[1]
			self.generos_count[genero[0]] = 0
			self.generos_pos[i]=genero[0]
			self.generos_id[genero[0]] = i
			self.ddlGenero.insertItem(genero[1])
			i=i+1
			
	def llenaddlTipo(self):
		sql = "SELECT id, nombre from tipos where borrado = 0 order by nombre asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		self.ddlTipo.clear()
		self.ddlTipo.insertItem("",-1)
		self.tipos = {}
		self.tipos_pos = {}
		self.tipos_count = {}
		self.tipos_id = {}
		i=1
		for tipo in rs:
			self.tipos[tipo[0]]=tipo[1]
			self.tipos_id[tipo[0]] = i
			self.tipos_count[tipo[0]] = 0
			self.tipos_pos[i] = tipo[0]
			self.ddlTipo.insertItem(tipo[1])
			i=i+1
	
	def llenaddlFormato(self):
		sql = "SELECT id, nombre from formatos where borrado = 0 order by nombre asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		self.ddlFormato.clear()
		self.ddlFormato.insertItem("",0)
		self.formatos={}
		self.formatos_pos = {}
		self.formatos_count = {}
		self.formatos_id = {}
		i=1
		for formato in rs:
			self.formatos[formato[0]] = formato[1]
			self.formatos_id[formato[0]] = i
			self.formatos_count[formato[0]] = 0
			self.formatos_pos[i] = formato[0]
			self.ddlFormato.insertItem(formato[1])
			i=i+1
		
	def llenaddlAnio(self):
		sql = "SELECT distinct anio from peliculas where borrado = 0 order by anio asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		self.ddlAnio.clear()
		self.ddlAnio.insertItem("",0)
		self.anios=[]
		self.anios_count={}
		
		for anio in rs:
			self.anios.append(anio[0])
			self.anios_count[anio[0]] = 0
			self.ddlAnio.insertItem(anio[0])
			
	def llenaddlLocalizacion(self):
		sql = "SELECT * from localizaciones where borrado = 0 order by nombre asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		self.ddlLocalizacion.clear()
		self.ddlLocalizacion.insertItem("",0)
		self.localizaciones={}
		self.localizaciones_pos = {}
		self.localizaciones_count = {}
		self.localizaciones_id = {}
		i=1
		for localizacion in rs:
			self.localizaciones[localizacion[0]] = localizacion[1]
			self.localizaciones_id[localizacion[0]]=i
			self.localizaciones_count[localizacion[0]] = 0
			self.localizaciones_pos[i] = localizacion[0]
			self.ddlLocalizacion.insertItem(localizacion[1])
			i=i+1
			
	def llenalstCatalogo(self):
		self.lstCatalogo.clear()
		self.lstCatalogo.setRootIsDecorated(1)
		#Aado y oculto las columnas de control
		
		if self.lstCatalogo.columns == 2:
			self.lstCatalogo.addColumn('id')
			self.lstCatalogo.addColumn('tipo')
			self.lstCatalogo.setColumnWidthMode(2,QListView.Manual)
			self.lstCatalogo.setColumnWidthMode(3,QListView.Manual)
			self.lstCatalogo.setColumnWidth(2,0)
			self.lstCatalogo.setColumnWidth(3,0)
			self.lstCatalogo.hideColumn(2)
			self.lstCatalogo.hideColumn(3)
			
		count_peliculas = str(len(self.peliculas))
		
		item = QListViewItem(self.lstCatalogo,None)
		item.setText(0,self.__tr("Todo"))
		item.setPixmap(0,self.image6)
		item.setText(1,count_peliculas)
		item.setText(3,"todo")
		item.setOpen(1)
		
		#Agregamos los gneros
		item_generos = QListViewItem(item,None)
		item_generos.setText(0,self.__tr('Gneros'))
		item_generos.setPixmap(0,self.image7)
		item_generos.setOpen(1)
		for genero in self.generos:
			item_g = QListViewItem(item_generos,None)
			item_g.setText(0,self.generos[genero])
			item_g.setText(1,str(self.generos_count[genero]))
			item_g.setText(2,str(genero))
			item_g.setText(3,"genero")
		
		#Agregamos la valoraciones
		item_valoraciones = QListViewItem(item,None)
		item_valoraciones.setText(0,self.__tr('Valoraciones'))
		item_valoraciones.setPixmap(0,self.image7)
		item_valoraciones.setOpen(1)
		valoracion = QListViewItem(item_valoraciones,None)
		valoracion.setText(0,str("0"))
		valoracion.setText(1,str(self.valoraciones_count[0]))
		valoracion.setText(2,str("0"))
		valoracion.setText(3,str("valoracion"))
		
		valoracion1 = QListViewItem(item_valoraciones,None)
		valoracion1.setText(0,str("1"))
		valoracion1.setText(1,str(self.valoraciones_count[1]))
		valoracion1.setPixmap(0,self.image1)
		valoracion1.setText(2,str("1"))
		valoracion1.setText(3,str("valoracion"))
		
		valoracion2 = QListViewItem(item_valoraciones,None)
		valoracion2.setText(0,str("2"))
		valoracion2.setText(1,str(self.valoraciones_count[2]))
		valoracion2.setPixmap(0,self.image2)
		valoracion2.setText(2,str("2"))
		valoracion2.setText(3,str("valoracion"))
		
		valoracion3 = QListViewItem(item_valoraciones,None)
		valoracion3.setText(0,str("3"))
		valoracion3.setText(1,str(self.valoraciones_count[3]))
		valoracion3.setPixmap(0,self.image3)
		valoracion3.setText(2,str("3"))
		valoracion3.setText(3,str("valoracion"))
				
		valoracion4 = QListViewItem(item_valoraciones,None)
		valoracion4.setText(0,str("4"))
		valoracion4.setText(1,str(self.valoraciones_count[4]))
		valoracion4.setPixmap(0,self.image4)
		valoracion4.setText(2,str("4"))
		valoracion4.setText(3,str("valoracion"))
		
		valoracion5 = QListViewItem(item_valoraciones,None)
		valoracion5.setText(0,str("5"))
		valoracion5.setText(1,str(self.valoraciones_count[5]))
		valoracion5.setPixmap(0,self.image5)
		valoracion5.setText(2,str("5"))
		valoracion5.setText(3,str("valoracion"))
		
		#Agregamos los Tipos
		item_tipos = QListViewItem(item,None)
		item_tipos.setText(0,self.__tr('Tipos'))
		item_tipos.setPixmap(0,self.image7)
		item_tipos.setOpen(0)
		for tipo in self.tipos:
			item_t = QListViewItem(item_tipos,None)
			item_t.setText(0,self.tipos[tipo])
			item_t.setText(1,str(self.tipos_count[tipo]))
			item_t.setText(2,str(tipo))
			item_t.setText(3,"tipo")
			
		#Agregamos los Formatos
		item_formatos = QListViewItem(item,None)
		item_formatos.setText(0,self.__tr('Formatos'))
		item_formatos.setPixmap(0,self.image7)
		item_formatos.setOpen(0)
		for formato in self.formatos:
			item_f = QListViewItem(item_formatos,None)
			item_f.setText(0,self.formatos[formato])
			item_f.setText(1,str(self.formatos_count[formato]))
			item_f.setText(2,str(formato))
			item_f.setText(3,"formato")
			
		#Agregamos los Aos
		item_anios = QListViewItem(item,None)
		item_anios.setText(0,self.__tr('Aos'))
		item_anios.setPixmap(0,self.image7)
		item_anios.setOpen(0)
		i=0
		for anio in self.anios:
			item_a = QListViewItem(item_anios,None)
			item_a.setText(0,str(anio))
			item_a.setText(1,str(self.anios_count[anio]))
			item_a.setText(2,str(i))
			item_a.setText(3,"anio")
			i=i+1
			
		#Agregamos las Localizaciones
		item_localizaciones = QListViewItem(item,None)
		item_localizaciones.setText(0,self.__tr('Localizaciones'))
		item_localizaciones.setPixmap(0,self.image7)
		item_localizaciones.setOpen(0)
		for localizacion in self.localizaciones:
			item_l = QListViewItem(item_localizaciones,None)
			item_l.setText(0,self.localizaciones[localizacion])
			item_l.setText(1,str(self.localizaciones_count[localizacion]))
			item_l.setText(2,str(localizacion))
			item_l.setText(3,"localizacion")
			
		self.lstCatalogo.hideColumn(2)
		self.lstCatalogo.hideColumn(3)
			
	def llenaTabla(self,busca=1):
		
		
		
		self.tbResultados.setNumRows(0)
        	self.tbResultados.setNumCols(8)
		sql = "SELECT id, nombre, genero, tipo, formato, anio, tamanio, localizacion, valoracion\
		 from peliculas where borrado = 0"
		
		
		if busca==1:
			#WHERE		
			if self.txtNombre.text().length() > 0:
				sql = sql+" AND nombre like '%"+self.codifica(self.txtNombre.text())+"%'"
			if self.ddlGenero.currentItem() > 0:
				sql = sql+" AND genero = "+str(self.generos_pos[self.ddlGenero.currentItem()])
			if self.ddlTipo.currentItem() > 0:
				sql = sql+" AND tipo = "+str(self.tipos_pos[self.ddlTipo.currentItem()])
			if self.ddlFormato.currentItem() > 0:
				sql = sql+" AND formato	 = "+str(self.formatos_pos[self.ddlFormato.currentItem()])
			if self.ddlLocalizacion.currentItem() > 0:
				sql = sql+" AND localizacion = "+str(self.localizaciones_pos[self.ddlLocalizacion.currentItem()])
			if self.ddlAnio.currentItem() > 0:
				sql = sql+" AND anio = '"+self.codifica(self.ddlAnio.currentText())+"'"
			if self.ddlValoracion.currentItem() > 0:
				sql = sql+" AND valoracion = '"+str(self.ddlValoracion.currentItem()-1)+"'"
		else:
			# Bug 2464539, al insertar o eliminar una pelcula se descuadraban los contadores	
			#Si no buscamos, restablecemos los contadores:
			for genero in self.generos_count: self.generos_count[genero]=0
			for tipo in self.tipos_count: self.tipos_count[tipo]=0
			for formato in self.formatos_count: self.formatos_count[formato]=0
			for localizacion in self.localizaciones_count: self.localizaciones_count[localizacion]=0
			for anio in self.anios_count: self.anios_count[anio]=0
		
		#Orden
		
		sql = sql+" ORDER BY nombre ASC"
		
		#print sql
		try:
			self.dbconn.execute(str(sql))
		except:
			QMessageBox.critical(self,'sMovieDB - Error','Error al ejecutar la bsqueda')
			print sql
			return
		
		rs = self.dbconn.fetchall()
		self.peliculas = {}
		self.valoraciones_count={}
		self.valoraciones_count[0]=0
		self.valoraciones_count[1]=0
		self.valoraciones_count[2]=0
		self.valoraciones_count[3]=0
		self.valoraciones_count[4]=0
		self.valoraciones_count[5]=0
		
		rows = 0
		for pelicula in rs:
			
			self.peliculas[rows] = pelicula[0]
			
			#Genero
			try:
				genero = self.generos[pelicula[2]]
				try:
					self.generos_count[pelicula[2]] = self.generos_count[pelicula[2]]+1
				except: nada = 0
			except:
				genero = 'No encontrado'
				
			#Tipo	
			try:
				tipo = self.tipos[pelicula[3]]
				try:
					self.tipos_count[pelicula[3]] = self.tipos_count[pelicula[3]]+1
				except: nada = 0
			except:
				tipo = 'No encontrado'
				
			#Formato
			try:
				formato = self.formatos[pelicula[4]]
				try:
					self.formatos_count[pelicula[4]] = self.formatos_count[pelicula[4]]+1
				except: nada = 0
			except:
				formato = 'No encontrado'
			
			#localizacion
			try:
				localizacion = self.localizaciones[pelicula[7]]
				try:
					self.localizaciones_count[pelicula[7]] = self.localizaciones_count[pelicula[7]]+1
				except: nada = 0
			except:
				localizacion = 'No encontrado'
				
			#Valoracion
			try:
				if(pelicula[8] == 0):
					valoracion = QPixmap()
					self.valoraciones_count[0]=self.valoraciones_count[0]+1
				if(pelicula[8] == 1):
					valoracion = self.image1
					self.valoraciones_count[1]=self.valoraciones_count[1]+1
				if(pelicula[8] == 2):
					valoracion = self.image2
					self.valoraciones_count[2]=self.valoraciones_count[2]+1
				if(pelicula[8] == 3):
					valoracion = self.image3
					self.valoraciones_count[3]=self.valoraciones_count[3]+1
				if(pelicula[8] == 4):
					valoracion = self.image4
					self.valoraciones_count[4]=self.valoraciones_count[4]+1
				if(pelicula[8] == 5):
					valoracion = self.image5
					self.valoraciones_count[5]=self.valoraciones_count[5]+1
					
			except:
				print "Valoracion no encontrada "+str(pelicula[8])
				valoracion = QPixmap()
				
			#Anio
			try:
				self.anios_count[pelicula[5]] = self.anios_count[pelicula[5]]+1
			except: nada = 0
			
			
			#Lo asociamos a la tabla
				
			self.tbResultados.setNumRows(rows+1)
			#Titulo
			self.tbResultados.setText(rows,0, pelicula[1])
			#Genero
			self.tbResultados.setText(rows,1, genero)
			#Tipo
			self.tbResultados.setText(rows,2, tipo)
			#formato
			self.tbResultados.setText(rows,3, formato)
			#Anio
			self.tbResultados.setText(rows,4, pelicula[5])
			#tamanio
			self.tbResultados.setText(rows,5, pelicula[6])
			#localizacion
			self.tbResultados.setText(rows,6, localizacion)
			#Valoracin
			self.tbResultados.setPixmap(rows,7,valoracion)
			rows=rows+1
			
			
		#Tabla como solo lectura
		self.tbResultados.setReadOnly(1)
		
		#Tabla Ordenable
		#self.tbResultados.setSorting(1)
		#self.tbResultados.setRowMovingEnabled(1)
	
	def insertar(self):
		
		self.frminsertar = frmInsertar()
		self.frminsertar.show()
		self.frminsertar.dbconn = self.dbconn
		self.frminsertar.db = self.db
		self.frminsertar.llenar(self)
		
	
	def tbResultados_onclick(self, row, col, button, qpoint):
		#print "Se ha pulsado doble click sobre la fila "+str(row)+" columna "+str(col)
		#print " que corresponde con la pelicula id = "+str(self.peliculas[row])
		
		if (row < 0 ) or ( col < 0): return
		self.frminsertar = frmInsertar()
		self.frminsertar.show()
		self.frminsertar.dbconn = self.dbconn
		self.frminsertar.cargar(self,self.peliculas[row])
		
	
	def preferencias(self):
		self.frmPreferencias = preferencias()
		self.frmPreferencias.show()
		self.frmPreferencias.onload(self)
		
	def ordenar(self):
		return
	
	def acercade(self):
		self.frmAcercaDe = frmacercade()
		self.frmAcercaDe.show()
		self.frmAcercaDe.lblName.setText("<b>sMovieDB "+version+"</b>")
		
	def acercadeqt(self):
		QMessageBox.aboutQt(self,self.__tr("Acerca de Qt"))
		
	def exportar(self):
		
		file = QFileDialog.getSaveFileName(os.environ["HOME"], self.__tr("Ficheros de datos SQLite (*.dat)"),self, str(self.__tr("sMovieDB - Exportar")), self.__tr("Seleccione el nombre del fichero a exportar") );
		
		if (len(file) > 0):
			
			if (file[-4:]!= ".dat"): file = file+".dat"
			confirm = 0
			
			if (QFile(file).exists()):
				confirm = QMessageBox.question(self,self.__tr("Sobreescribir"),self.__tr("El fichero ya existe. Deseas reemplazarle?"),self.__tr("&Si"), self.__tr("&No"), QString.null, 1, 1 )
			
			if confirm == 0:
			
				try:
					shutil.copy(os.environ["HOME"] + "/.smoviedb/smoviedb.dat", file )
					QMessageBox.information(self,self.__tr('sMovieDB - Informacin'),self.__tr('Exportacin finalizada.\nSe ha generado una copia de los datos en el lugar indicado.'))
				except:
					QMessageBox.critical(self,self.__tr('sMovieDB - Informacin'),self.__tr('La exportacion no ha podido completarse.'))

		
		return

	def importar(self):
		
		file = QFileDialog.getOpenFileName(os.environ["HOME"], self.__tr("Ficheros de datos SQLite (*.dat)"),self, str(self.__tr("sMovieDB - Importar")), self.__tr("Seleccione el fichero a importar") );
			
		confirm = 1
		if (len(file) > 0):
  			confirm = QMessageBox.question(self,self.__tr("Remplazo de datos"),self.__tr("Desea Reemplazar los datos existentes por los del fichero de importacin?"),self.__tr("&Si"), self.__tr("&No"), QString.null, 1, 1 )
						#( QWidget * parent, const QString & caption, const QString & text, const QString & button0Text = QString::null, const QString & button1Text = QString::null, const QString & button2Text = QString::null, int defaultButtonNumber = 0, int escapeButtonNumber = -1 )

		if confirm == 0:
			
			import time
			ahora = time.strftime("%Y%m%d%H%M%S", time.localtime())
			
			#Guardamos copia de seguridad
			shutil.copy(os.environ["HOME"] + "/.smoviedb/smoviedb.dat", os.environ["HOME"] + "/.smoviedb/smoviedb-"+ahora+".dat")
			#Copiamos el fichero importado
			try:
				shutil.copy(file, os.environ["HOME"] + "/.smoviedb/smoviedb.dat")
				QMessageBox.information(self,self.__tr('sMovieDB - Informacin'),self.__tr('Importacin finalizada.\nSe ha generado una copia de seguridad de los datos antiguos.'))
			except:
				QMessageBox.critical(self,self.__tr('sMovieDB - Informacin'),self.__tr('La importacin no ha podido completarse.'))
				
	def cambiaridioma(self):
		self.idioma = frmIdioma()
		self.idioma.show()
		self.idioma.cargar(self)
	
	def aplicaidioma(self):
		#file = self.AbreFileConfig()
		#buffer = file.read()
		#file.close()
		
		#config = buffer.split('\n')
		self.conf = configuracion()
		if (self.conf.LeeConfiguracion('dbtype')==''):
			self.asistenteConfInicial()
			
		translator = QTranslator(qApp)
		
		if (self.conf.LeeConfiguracion('idioma') != ''):
		
			# Idioma de configuracin
			
			a=translator.load("langs/"+str(self.conf.LeeConfiguracion('idioma'))+".qm")
			
			if a==0:
				print "No translation for "+self.conf.LeeConfiguracion('idioma')+"\nNo se encuentra el idioma "+self.conf.LeeConfiguracion('idioma')
			else:
				print "Load "+self.conf.LeeConfiguracion('idioma')
				
			qApp.installTranslator(translator)
		else:
			# Idioma del locale del sistema
			
			locale = QLocale.system().name();
			
			#locale = "en_EN"
			
			a=translator.load("langs/"+str(locale)+".qm")
			
			if a==0:
				print "No translation for "+locale+"\nNo se encuentra el idioma "+locale
			else:
				print "Load "+locale
				
			qApp.installTranslator(translator)
		
		self.languageChange()
		#Restaurar el estado de los elementos ocultos
			
		if (self.conf.LeeConfiguracion('toolbar', 'vista') != ''):
			self.Toolbar.setHidden(not int(self.conf.LeeConfiguracion('toolbar', 'vista')))
			self.verBarra_de_HerramientasAction.setOn(int(self.conf.LeeConfiguracion('toolbar', 'vista')))
		if (self.conf.LeeConfiguracion('search','vista') != ''):
			self.groupBox1.setHidden(not int(self.conf.LeeConfiguracion('search','vista')))
			self.verBsquedaAction.setOn(int(self.conf.LeeConfiguracion('search','vista')))
		if (self.conf.LeeConfiguracion('catalog', 'vista') != ''):
			self.lstCatalogo.setHidden(not int(self.conf.LeeConfiguracion('catalog', 'vista')))
			self.verCatlogoAction.setOn(int(self.conf.LeeConfiguracion('catalog', 'vista')))
		if (self.conf.LeeConfiguracion('buttons', 'vista') != ''):
			self.fraBotonesRapidos.setHidden(not int(self.conf.LeeConfiguracion('buttons', 'vista')))
			self.verAcciones_RpidasAction.setOn(int(self.conf.LeeConfiguracion('buttons', 'vista')))
			
		#Autoconectar si procede
		
		if (self.conf.LeeConfiguracion('autoconnect') == "1"):
			self.conectar()
		
		
		
	def lstCatalogoClick(self,QListViewItem,pnt,c=-1):
		
		self.lstCatalogo.hideColumn(2)
		self.lstCatalogo.hideColumn(3)
		
		try:
			#print "Pulsado "+str(QListViewItem.text(3))+" id "+str(QListViewItem.text(2))+" "+str(c)
			
			
			
			if str(QListViewItem.text(3))!="":
				self.poneddlBusquedaBlanco()
			
			if str(QListViewItem.text(3))=="genero":
				self.ddlGenero.setCurrentItem(self.generos_id[int(QListViewItem.text(2))])
			if str(QListViewItem.text(3))=="tipo":
				self.ddlTipo.setCurrentItem(self.tipos_id[int(QListViewItem.text(2))])
			if str(QListViewItem.text(3))=="formato":
				self.ddlFormato.setCurrentItem(self.formatos_id[int(QListViewItem.text(2))])
			if str(QListViewItem.text(3))=="localizacion":
				self.ddlLocalizacion.setCurrentItem(self.localizaciones_id[int(QListViewItem.text(2))])
			if str(QListViewItem.text(3))=="valoracion":
				self.ddlValoracion.setCurrentItem(int(QListViewItem.text(2))+1)
			if str(QListViewItem.text(3))=="anio":
				self.ddlAnio.setCurrentItem(int(QListViewItem.text(2))+1)
					
			if str(QListViewItem.text(3))!="":
				self.llenaTabla(1)
		except:
			#print "Error"
			self.error = 1
		
		return
		
	def poneddlBusquedaBlanco(self):
		# Bug 2468636, no limpia el nombre
		self.txtNombre.setText('')
		self.ddlGenero.setCurrentItem(0)
		self.ddlTipo.setCurrentItem(0)
		self.ddlFormato.setCurrentItem(0)
		self.ddlLocalizacion.setCurrentItem(0)
		self.ddlValoracion.setCurrentItem(0)
		self.ddlAnio.setCurrentItem(0)
		
	def verBarraHerramientasClick(self, status):
		self.Toolbar.setHidden(not status)
		self.conf.GuardaConfiguracion('toolbar', status, 'vista')
		self.conf.GuardarFichero()
			
	def verBusquedaClick(self,status):
		self.groupBox1.setHidden(not status)
		self.conf.GuardaConfiguracion('search', status, 'vista')
		self.conf.GuardarFichero()

	def verCatalogoClick(self, status):
		self.lstCatalogo.setHidden(not status)
		self.conf.GuardaConfiguracion('catalog', status, 'vista')
		self.conf.GuardarFichero()
		
	def verAccionesRapidasClick(self, status):
		self.fraBotonesRapidos.setHidden(not status)
		self.conf.GuardaConfiguracion('buttons', status, 'vista')
		self.conf.GuardarFichero()
		
	def asistenteConfInicial(self):
		self.frmConfInicial = frmConfInicial()
		self.frmConfInicial.show()
		self.frmConfInicial.frmParent = self
		self.frmConfInicial.helpButton().setHidden(1)
		self.frmConfInicial.nextButton().setText(self.__tr("Siguiente >"))
		self.frmConfInicial.backButton().setText(self.__tr("< Atrs"))
		self.frmConfInicial.cancelButton().setText(self.__tr("Cancelar"))
		self.frmConfInicial.finishButton().setText(self.__tr("Finalizar"))
		self.frmConfInicial.setNextEnabled(self.frmConfInicial.WizardPage,0)
		

	def codifica(self,texto):
		if self.dbtype=='mysql':
			return str(texto.latin1())
		else:
			return str(texto.utf8())

		
	
	
class frmInsertar(frminsertar):
	
	
	
	def __tr(self,s,c = None):
		return qApp.translate("frminsertar",s,c)
	
	def llenar(self, frmparent):
		self.llenaddlGenero()
		self.llenaddlTipo()
		self.llenaddlFormato()
		self.llenaddlLocalizacion()
		self.frmParent = frmparent
		self.btnInsertar.setHidden(0)
		self.btnModificar.setHidden(1)
		self.btnEliminar.setHidden(1)
		self.DatosNuevaCaratula = ''
		
		imgPelicula_Data= QPixmap('./icons/smoviedb.png')
		self.imgPelicula.setPixmap(imgPelicula_Data)
	
	def cargar(self, frmparent,id_pelicula):		
		
		self.llenar(frmparent)
		self.btnInsertar.setHidden(1)
		self.btnModificar.setHidden(0)
		self.btnEliminar.setHidden(0)
		sql = "SELECT * from peliculas where id = "+str(id_pelicula)
		self.dbconn.execute(sql)
		peli_row = self.dbconn.fetchall()
		self.id= peli_row[0][0]
		self.txtNombre.setText(peli_row[0][1])
		self.txtAnio.setText(peli_row[0][5])
		self.txtTamanio.setText(peli_row[0][6])
		self.txtOpinion.setText(peli_row[0][8])
		#Desplegables
		try: 
			self.ddlGenero.setCurrentItem(self.generos_id[peli_row[0][2]]) 
		except:
			#print "No encontrado el genero para posicionar"
			self.error = 1
			
		try:
			self.ddlTipo.setCurrentItem(self.tipos_id[peli_row[0][3]])
		except:
			#print "No encontrado el tipo para posicionar"
			self.error = 1
			
		try:
			self.ddlFormato.setCurrentItem(self.generos_id[peli_row[0][4]])
		except:	
			#print "No encontrado el formato para posicionar"
			self.error = 1
			
		try:
			self.ddlLocalizacion.setCurrentItem(self.localizaciones_id[peli_row[0][7]])
		except:
			#print "No encontrada la localizacion para posicionar"
			self.error = 1
			
		try:
			self.ddlValoracion.setCurrentItem(peli_row[0][9])
		except:
			#print "No encontrada la valoracion para posicionar"
			self.error = 1
			
		# hay imgen de cartula:
		
		try:
			sql2 = "SELECT datos from caratulas where id_pelicula = "+str(id_pelicula)
			self.dbconn.execute(sql2)
			res = self.dbconn.fetchall()
			
			for c_row in res:
				
				imgPelicula_Data= QPixmap()
				imgPelicula_Data.loadFromData(base64.b64decode(c_row[0]),"JPEG")
				self.imgPelicula.setPixmap(imgPelicula_Data)
			
		except:
			
			
			try:
				#probamos a crear la tabla de caratulas, por si es una versin anterior y no exista
				sql = "CREATE TABLE caratulas (datos BLOB, id_pelicula INTEGER PRIMARY KEY)"
				self.dbconn.execute(sql)
				#si no ha fallado intentamos cargar de nuevo la caratula
				cargar(self, frmparent,id_pelicula)
				return 0
			except:
				QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al cargar la cartula'))	
			
		
	def cambiarCaratula(self):
		
		str_file = QFileDialog.getOpenFileName(os.environ["HOME"], self.__tr("Imagen JPEG (*.jpg)"),self, self.__tr("sMovieDB - Insertar Cartula"), self.__tr("Seleccione la imagen de la cartula") );
		if (len(str_file) > 0):
		
			file = open(str_file,'rb')	
			imgPelicula_Data= QPixmap()
			data = file.read()
			if (len(data) / 1024) > 33:
				file.close()
				QMessageBox.critical(self,'sMovieDB - Error',self.__tr('La imagen JPG no puede suerar los 30 Kb de tamao.'))
				return 0
			imgPelicula_Data.loadFromData(data,"JPEG")		
			file.close()
			
			self.imgPelicula.setPixmap(imgPelicula_Data)
			self.DatosNuevaCaratula = data
		
		
	def llenaddlGenero(self):
		sql = "SELECT id, nombre from generos where borrado = 0 order by id asc"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		self.ddlGenero.clear()
		self.ddlGenero.insertItem("",0)
		self.generos = {}
		self.generos_id = {}
		i=1
		self.generos[0]='0'
		for genero in rs:
			self.generos[i] = genero[0]
			self.generos_id[genero[0]] = i
			self.ddlGenero.insertItem(genero[1])
			i=i+1
			
	def llenaddlTipo(self):
		sql = "SELECT id, nombre from tipos where borrado = 0"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		self.ddlTipo.clear()
		self.ddlTipo.insertItem("",0)
		self.tipos = {}
		self.tipos_id = {}
		i=1
		self.tipos[0]='0'
		for tipo in rs:
			self.tipos[i]=tipo[0]
			self.tipos_id[tipo[0]] = i
			self.ddlTipo.insertItem(tipo[1])
			i=i+1
	
	def llenaddlFormato(self):
		sql = "SELECT id, nombre from formatos where borrado = 0"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		self.ddlFormato.clear()
		self.ddlFormato.insertItem("",-1)
		self.formatos={}
		self.formatos_id={}
		i=1
		self.formatos[0]='0'
		for formato in rs:
			self.formatos[i] = formato[0]
			self.formatos_id[formato[0]] = i
			self.ddlFormato.insertItem(formato[1])
			i=i+1
			
	def llenaddlLocalizacion(self):
		sql = "SELECT `id`, nombre from localizaciones where borrado = 0"
		self.dbconn.execute(sql)
		rs = self.dbconn.fetchall()
		self.ddlLocalizacion.clear()
		self.ddlLocalizacion.insertItem("",-1)
		self.localizaciones={}
		self.localizaciones_id={}
		i=1
		self.localizaciones[0]='0'
		for localizacion in rs:
			self.localizaciones[i] = localizacion[0]
			self.localizaciones_id[localizacion[0]]=i
			self.ddlLocalizacion.insertItem(localizacion[1])
			i=i+1
	
	def insertar(self):
		
		sql = "INSERT INTO peliculas VALUES (NULL , "
	
		sql = sql + "'" + self.frmParent.codifica(self.txtNombre.text()) + "'"
		sql = sql + ",'" + str(self.generos[self.ddlGenero.currentItem()]) + "'"
		sql = sql + ",'" + str(self.tipos[self.ddlTipo.currentItem()]) + "'"
		sql = sql + ",'" + str(self.formatos[self.ddlFormato.currentItem()]) + "'"
		sql = sql + ",'" + self.frmParent.codifica(self.txtAnio.text()) + "'"
		sql = sql + ",'" + self.frmParent.codifica(self.txtTamanio.text()) + "'"
		sql = sql + ",'" + str(self.localizaciones[self.ddlLocalizacion.currentItem()]) + "'"
		sql = sql + ",'" + self.frmParent.codifica(self.txtOpinion.text()) + "'"
		sql = sql + ",'" + str(self.ddlValoracion.currentItem()) + "'"
		sql = sql + ",0)"
				
		try:
			self.dbconn.execute(str(sql))
			
			try:
				if len(self.DatosNuevaCaratula)>0:
					sql4 = "SELECT max(id) from peliculas"
					self.dbconn.execute(str(sql4))
					ultimo_id = self.dbconn.fetchall()
					
					sql2 = "DELETE FROM caratulas WHERE id_pelicula = " + str(ultimo_id[0][0])
					sql3 = "INSERT INTO caratulas (id_pelicula, datos) VALUES ('" + str(ultimo_id[0][0]) + "', '"+ base64.b64encode(self.DatosNuevaCaratula) +"')"
					
					
					
					self.dbconn.execute(str(sql2))
					self.dbconn.execute(str(sql3))
			except:

				try:
					#probamos a crear la tabla de caratulas, por si es una versin anterior y no exista
					sql = "CREATE TABLE caratulas (datos BLOB, id_pelicula INTEGER PRIMARY KEY)"
					self.dbconn.execute(sql2)
					#si no ha fallado intentamos cargar de nuevo la caratula
					cargar(self, frmparent,id_pelicula)
					return 0
				except:
					QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardar la cartula'))
			try:
				self.dbconn.execute('commit;');
			except:
				error=1
		except:
			QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al insertar la pelcula'))
			print sql
			return
		
		self.frmParent.llenaTabla(0)
		self.frmParent.llenalstCatalogo()
		self.cerrar()
		
	def modificar(self):
		
		
		sql = "UPDATE peliculas set "
		sql = sql+"nombre='"+self.frmParent.codifica(self.txtNombre.text())+"', "
		sql = sql+"genero='"+str(self.generos[self.ddlGenero.currentItem()]) + "', "
		sql = sql+"tipo='"+str(self.tipos[self.ddlTipo.currentItem()])+"',"
		sql = sql+"formato='"+str(self.formatos[self.ddlFormato.currentItem()])+"', "
		sql = sql+"anio='"+self.frmParent.codifica(self.txtAnio.text())+"', "
		sql = sql+"tamanio='"+self.frmParent.codifica(self.txtTamanio.text())+"', "
		sql = sql+"localizacion='"+str(self.localizaciones[self.ddlLocalizacion.currentItem()])+"', "
		sql = sql+"opinion='" + self.frmParent.codifica(self.txtOpinion.text()) + "', "
		sql = sql+"valoracion='" + str(self.ddlValoracion.currentItem()) + "' "
		sql = sql+" WHERE id="+str(self.id)
		
		
		
		try:
			self.dbconn.execute(str(sql))
			
			try:
				if len(self.DatosNuevaCaratula)>0:
			
					sql2 = "DELETE FROM caratulas WHERE id_pelicula = " + str(self.id)
					sql3 = "INSERT INTO caratulas (id_pelicula, datos) VALUES ('" + str(self.id) + "', '"+ base64.b64encode(self.DatosNuevaCaratula) +"')"
					
					self.dbconn.execute(str(sql2))
					self.dbconn.execute(str(sql3))
			except:
				QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al guardar la cartula'))
				#print sql2
				#print sql3
			
			try:
				self.dbconn.execute('commit;');
			except:
				error=1
		except:
			QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al modificar la pelcula'))
			print sql
			return
			
		
		
			
		
		self.frmParent.llenaTabla(0)
		self.frmParent.llenalstCatalogo()
		self.cerrar()
		
	def eliminar(self):
		sql = "UPDATE peliculas set borrado = 1 where id = "+str(self.id)
		#print sql
		try:
			self.dbconn.execute(str(sql))
			try:
				self.dbconn.execute('commit;');
			except:
				error=1
		except:
			QMessageBox.critical(self,'sMovieDB - Error',self.__tr('Error al eliminar la pelcula'))
			print sql
			return
		
		self.frmParent.llenaTabla(0)
		self.frmParent.llenalstCatalogo()
		self.cerrar()
		
	def cerrar(self):
		#self.frmParent.btnInsertar.setEnabled(1)
		self.close()
	



# Funcion Main principal

def main():
	#Creamos un objeto QApplication
	app = QApplication(sys.argv)

	#Realizamos una conexion para que cuando termine la ejecucion
	#de la aplicacion nos devuelva el control
	app.connect(app,SIGNAL('lastWindowClosed()'),app,SLOT('quit()'))
	#Creamos una instancia de nuestro formulario
	frm = frmMovie()
	app.setMainWidget(frm)

	#Mostramos el formulario
	frm.show()
	frm.conectado = 0
	frm.aplicaidioma()	
	#Bucle que controla nuestro programa
	app.exec_loop()
	

#Ejecutamos Main
main() 
